// package JavaCode;

import java.io.File;

public class CreateDB2 {
	public static void main(String[] args) throws Exception {
		if (args.length < 1) {
			System.err.println("Please supply a configuration file");
			return;
		}

		if (args.length > 0) {
			Parameters.read(args[0]);
			Parameters.fSortSize = 6000000;
			Oligo.fillCode();
			if(!(new File(Parameters.pathDB + Parameters.DATABASE)).mkdir()) {
				System.err.println("Database '" + Parameters.pathDB + Parameters.DATABASE + "' already exist\n");
			} else {
				System.err.println("DB Size:\t" + Parameters.dbOligoSize + "\tSeed Size:\t" + Parameters.seedSize);
				CreateDB2Ob dbObj = new CreateDB2Ob();
				dbObj.dbChart();
				dbObj.sequencability(36);
				dbObj.sequencability0();
			}
		}
	}
}
