// package JavaCode;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;

public class CreateSequences {

	static ReferenceSequences rs;
	
	public static void main(String[] args) throws Exception {
		int ux = 0;
		int noFiles = 0;
		int x = 0;
		int nd;
		int cSize;
		// int noFiles = 0;
		String[] prbFiles = null;
		ReferenceSequences.ux = ux;
		
		nd    = 0;
		cSize = 0;
		if (args.length == 1 || args.length == 3) {
			Parameters.read(args[0]);
			if (args.length == 3) {
				nd    = new Integer(args[1]).intValue();
				cSize = new Integer(args[2]).intValue();
				BufferedReader reader = new BufferedReader(new FileReader("prbFileList.txt"));
				String line = reader.readLine();
				noFiles     = new Integer(line).intValue();
				prbFiles = new String[noFiles];
				for (int i = 0; i < noFiles; i++) {
					prbFiles[i] = reader.readLine();
				}
				reader.close();
			} else {
				File fl = new File(Parameters.pathPRB);
				File[] dirs = fl.listFiles();
				for (int dd = 0; dd < dirs.length; dd++) {
					if(dirs[dd].isDirectory()) {
				        File[] files = dirs[dd].listFiles();
				        for(int i=0; i<files.length; i++) {
				            if(!files[i].isDirectory() && (files[i].toString()).indexOf("prb") >= 0) {
				            	noFiles++;
				            }
				        }
					}
				}
				prbFiles = new String[noFiles];
				for (int dd = 0; dd < dirs.length; dd++) {
					if(dirs[dd].isDirectory()) {
				        File[] files = dirs[dd].listFiles();
				        for(int i=0; i<files.length; i++) {
				            if(!files[i].isDirectory() && (files[i].toString()).indexOf("prb") >= 0) {
				            	prbFiles[x] = new String(files[i] + "");
				            	x++;
				            }
				        }
					}
				}
			}
			
			// String conPathSeq = Parameters.pathConRefSeq;
			// String noiseDB = Parameters.pathData + "contaminationDB/";

			Parameters.resetTime();
			ReferenceSequences.display = false;
			
			rs = new ReferenceSequences();
			Oligo.fillCode();

			if(!(new File(Parameters.pathData)).mkdir()) {
				System.err.println("Faile to create the directory " + Parameters.pathData);
			}
			if(!(new File(Parameters.pathOut)).mkdir()) {
				System.err.println("Faile to create the directory " + Parameters.pathOut);
			}
			// rs.processContamination(conPathSeq, noiseDB);

			if (Parameters.skipCycles < 0) {
				Parameters.skipValue = true;
			} else {
				Parameters.skipValue = false;
			}
			if (Parameters.ETag == Parameters.SET) {
				System.err.println("SET:\t" + Parameters.pathData + Parameters.outFile);
				//-----------------------------------------------------------------------------------------nodeId, clusterSize);
				rs.generateOligosFromPRB_SET2(prbFiles, nd, cSize);
			} else if (Parameters.ETag == Parameters.PET) {
				System.err.println("PET:\t" + Parameters.pathData + Parameters.outFile);
				rs.generateOligosFromPRB_PET2(prbFiles, nd, cSize);
			} 
			System.err.print("\nTotal Execution time is: ");
			Parameters.printTime(Parameters.numberOfTimePoints - 1);
			System.err.println();
		} else {
			System.err.println("CreateSequences parameterFile [nodeNumber clusterSize]");
		}
	}	

}
